package cn.iocoder.yudao.module.system.controller.admin.home;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceCategoryPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceCategoryPageRespVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceCategoryRespVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceCategorySaveReqVO;
import cn.iocoder.yudao.module.system.service.home.HomeServiceCategoryService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 居家服务类别")
@RestController
@RequestMapping("/home/service-category")
@Validated
public class HomeServiceCategoryController {

    @Resource
    private HomeServiceCategoryService homeServiceCategoryService;

    @PostMapping("/create")
    @Operation(summary = "新增居家服务类别")
    @TenantIgnore
    public CommonResult<Long> create(@Valid @RequestBody HomeServiceCategorySaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServiceCategoryService.createHomeServiceCategory(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "修改居家服务类别")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody HomeServiceCategorySaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        homeServiceCategoryService.updateHomeServiceCategory(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除居家服务类别")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        homeServiceCategoryService.deleteHomeServiceCategory(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得居家服务类别详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<HomeServiceCategoryRespVO> get(@RequestParam("id") Long id) {
        return success(homeServiceCategoryService.getHomeServiceCategory(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得居家服务类别分页")
    @TenantIgnore
    public CommonResult<PageResult<HomeServiceCategoryPageRespVO>> page(@Valid HomeServiceCategoryPageReqVO pageReqVO) {
        if (pageReqVO.getTenantId() == null) {
            pageReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServiceCategoryService.getHomeServiceCategoryPage(pageReqVO));
    }
}
